#include <iostream>
#include <math.h>
#include <vector>
#include <SFML\Graphics.hpp>
#include "Particle.h"
#include "const.h"
#include <SFML\OpenGL.hpp>


using namespace std;

float modOfVector(sf::Vector2f & v) { //   
	return sqrt(v.x*v.x + v.y*v.y); 
}
float getDistance(sf::Vector2f && v1, sf::Vector2f && v2) noexcept { //    
	return sqrt(pow((v2.x - v1.x), 2) + pow((v2.y - v1.y), 2));
}

void particleTransform(vector <Particle>const & part, float ** & i_vec){ //      ,   
	for (int i = 0; i < NUMB_OF_BLOCK; ++i) {
		for (int j = 0; j < PART_IN_BLOCK; ++j) {
			i_vec[i][j * 2] = part[j + i*PART_IN_BLOCK].getPosition().x;
			i_vec[i][j * 2 + 1] = part[j + i*PART_IN_BLOCK].getPosition().y;
		}
	}
}

int main() {
	sf::ContextSettings set;
	set.antialiasingLevel = 8; //   ,      
	sf::RenderWindow window(sf::VideoMode(winW, winH), "PS", sf::Style::Default, set); //  ,    . winW & winH -   const.h
	
	vector <Particle> all_part; //  

	float ** coords = new float * [NUMB_OF_BLOCK]; //     ,  
	
	for (int i = 0; i < NUMB_OF_BLOCK; ++i)
		coords[i] = new float[PART_IN_BLOCK * 2];
	
	unsigned char ** colors = new unsigned char *[NUMB_OF_BLOCK]; //  ,      
	for (int i = 0; i < NUMB_OF_BLOCK; ++i)
		colors[i] = new unsigned char[PART_IN_BLOCK * 3];

	for (int i = 0; i < NUMB_OF_BLOCK; i++) {
		for (int j = 0; j < PART_IN_BLOCK; j++) {// sf::Vector2f(200, 100) -    
			srand(time(0));
			int mass = 10 + rand() %  70; //       10  79
			Particle tmp(mass, sf::Vector2f(20, 100) + sf::Vector2f(j*0.6, i*3)); //   
			all_part.push_back(tmp);
			coords[i][2*j] = tmp.getPosition().x; //     
			coords[i][2*j +1] = tmp.getPosition().y;
		}
	}

	////////////////// OpenGL settings
	glEnable(GL_POINT_SMOOTH); //       
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

	glPointSize(1); //   - 1 
	glOrtho(0, winW, winH, 0, 1, -1); //   
	//////////////////////////////////

	bool LB_press = 0;

	sf::Clock clock; // ,         
	float frame_time = 0.1f;

	sf::Event event;
	while (window.isOpen()) {
		while (window.pollEvent(event)) {
			if (event.type == sf::Event::Closed)
				window.close();
		}
		if (sf::Mouse::isButtonPressed(sf::Mouse::Left))//    
			LB_press = 1;
		else
			LB_press = 0;

		glClear(GL_COLOR_BUFFER_BIT); //  
		
		for (auto it = 0; it < all_part.size(); ++it) {
			if (LB_press) { //   ,     
				sf::Vector2f mouse = sf::Vector2f(sf::Mouse::getPosition(window)); //      
				all_part[it].addForce((mouse - all_part[it].getPosition()) * (G / pow(getDistance(move(mouse), all_part[it].getPosition()) + 5, 2)));
				all_part[it].addForce(-all_part[it].getSpeed()*100.0f); //   ( ),  100*f     ,   -     .
			}
			// 
			all_part[it].update(move(frame_time)); //   update   ,          
			if (LB_press) all_part[it].cler_force(); //   

		}

		glPushMatrix();

		particleTransform(all_part, coords); //       

		glEnableClientState(GL_VERTEX_ARRAY);
		glEnableClientState(GL_COLOR_ARRAY);

		
		for (int i = 0; i < NUMB_OF_BLOCK; ++i) {
			for (int j = 0; j < PART_IN_BLOCK; ++j) { //    ,     
				colors[i][3 * j] = 152;
				colors[i][3 * j + 1] =  50 + static_cast <int> (modOfVector(all_part[j + i*PART_IN_BLOCK].getSpeed())); //    
				colors[i][3 * j + 2] = 10 + static_cast <int> (modOfVector(all_part[j + i*PART_IN_BLOCK].getSpeed())) ;
			}
		}

		for (int i = 0; i < NUMB_OF_BLOCK; ++i) {
			glVertexPointer(2, GL_FLOAT, 0, coords[i]); //  -  ,       
			glColorPointer(3, GL_UNSIGNED_BYTE, 0, colors[i]); //  ,   .
			glDrawArrays(GL_POINTS, 0, PART_IN_BLOCK); //    .    ,     (  0, ..  )   .

		}

		glDisableClientState(GL_VERTEX_ARRAY);
		glDisableClientState(GL_COLOR_ARRAY);

		glPopMatrix();

		glFlush();
		window.display(); //  .
		frame_time = clock.restart().asSeconds(); //      .

	}
	for (int i = 0; i < NUMB_OF_BLOCK; ++i) //   .
		delete[] coords[i];
	for (int i = 0; i < NUMB_OF_BLOCK; ++i) //   .
		delete[] colors[i];
	return 0;
}



